# Building

## Dependencies

 - C++ compiler supporting C++17, e.g. [GCC](https://gcc.gnu.org/) 7 and later.
 - [GNU Make](https://www.gnu.org/software/make/).
 - [Boost](http://www.boost.org/) 1.58 or higher with the following libraries: program options, filesystem and iostreams.
 - [zlib](http://www.zlib.net/).
 - [CMake](https://cmake.org/) 3.11 or higher.
 - JDK 10 or higher, either from [Oracle](http://www.oracle.com/technetwork/java/javase/downloads/index.html) or [OpenJDK](http://openjdk.java.net/projects/jdk/10/).

**Ubuntu 18.04**

On Ubuntu 18.04, all dependencies except for CMake 3.11 can be installed as follows:
```
sudo apt install g++ make libboost-dev libboost-program-options-dev libboost-filesystem-dev libboost-iostreams-dev zlib1g-dev openjdk-11-jdk
```
To install CMake 3.11 and obtain newer Java certificaties, which are needed for building Strix,
one can use the packages from the future Ubuntu distribution `cosmic` as follows:
 - Add the following lines to `/etc/apt/sources.list`:
   ```
   deb http://archive.ubuntu.com/ubuntu/ cosmic restricted main multiverse universe
   deb http://archive.ubuntu.com/ubuntu/ cosmic-proposed restricted main multiverse universe
   ```
 - Add the following to a new file `/etc/apt/preferences.d/cosmic.pref`:
   ```
   Package: *
   Pin: release n=cosmic
   Pin-Priority: -10
   ```
 - Run the following:
   ```
   sudo apt update
   sudo apt install cmake/cosmic-proposed
   sudo apt install ca-certificates-java/cosmic
   ```

**Arch Linux**

On Arch Linux, all dependencies can be installed as follows:
```
sudo pacman -S gcc cmake make boost boost-libs jdk10-openjdk zlib
sudo archlinux-java set java-10-openjdk
```

## Compilation

If the repository has been cloned with git, first the submodules have to be initialized.
If Strix has been obtained as a release zip file, this step can be skipped.
```
git submodule init
git submodule update
```

The compilation process can be started by:
```
make
```

After compilation, the folder `bin` will be created and should contain the executable `strix` and the library `owl.jar`.
To use strix, the executable `strix` has to be invoked, but the `owl.jar` library has to remain in the same directory,
or its location has to be given with the `--classpath` option.
