# Usage

Strix accepts specifcations in basic TLSF or LTL, for more details see the [formats description](FORMATS.md).

To check realizability of a basic TLSF specification, Strix should be invoked as follows:
```
strix --realizability SPEC.basic.tlsf
```
To output a controller as a Mealy machine, use:
```
strix -k SPEC.basic.tlsf
```
To output a controller as an AIGER circuit, simply use:
```
strix SPEC.basic.tlsf
```
To find a small AIGER circuit by additional minimization of the Mealy machine and usage of different state labels, use:
```
strix --auto SPEC.basic.tlsf
```
Instead of giving a TLSF file, one can also give the formula and the splitting on the command line as follows, where
`INS` and `OUTS` are comma-separated lists of input and output propositions:
```
strix -f "LTL_FORMULA" --ins="INS" --outs="OUTS"
```
For example, a simple arbiter with two clients can be synthesized as follows:
```
strix -f "G (req0 -> F grant0) && G (req1 -> F grant1) && G (!(grant0 && grant1))" --ins="req0,req1" --outs="grant0,grant1"
```

Strix has many more options, to list them use `strix --help`.
