# Building

## Prerequisites

Building the project from source requires an installed [JDK 10](http://jdk.java.net/10/) and an installed C++17 compiler. Furthermore to generate HTML documentation [pandoc](https://pandoc.org/) is needed.

Owl is built with [Gradle](http://gradle.org/), which is automatically bootstrapped. You can view the available tasks with:

```
$ ./gradlew tasks
```

## Standard Distribution

The standard distribution can be obtained with:

```
$ ./gradlew distZip
```

The resulting `.zip` is located in `build/distributions`. In order to run all tests and checks please use:

```
$ ./gradlew check
```

## Minimized Distribution

In order to save space and reduce load time of the application a minimized `jar` can be produced with:

```
$ ./gradlew minimizedDistZip
```

The minimization uses [ProGuard](https://www.guardsquare.com/en/products/proguard), removes unused `class`-files from the jar and does other minimizations.

## Documentation

The corresponding javadoc can be obtained with:

```
$ ./gradlew javadoc
```