#include "LTLParser.h"

#include <iostream>
#include <sstream>

namespace ltl {

LTLParser::LTLParser(const owl::OwlThread& owl) : Parser(owl) { }

LTLParser::~LTLParser() { }

owl::Formula LTLParser::parse_string_with_factory(
        owl::FormulaFactory& factory,
        const std::string& text,
        std::vector<std::string>& inputs, std::vector<std::string>& outputs
) const {
    // Create list of variables for parser
    std::vector<std::string> variables;

    variables.insert(variables.end(), inputs.cbegin(), inputs.cend());
    variables.insert(variables.end(), outputs.cbegin(), outputs.cend());

    // Parse with provided mapping
    return factory.parse(text, variables);
}

}
