#pragma once

#include "Definitions.h"

#include "owl.h"

namespace ltl {

class Parser {
private:
    const owl::OwlThread& owl;

protected:
    Parser(const owl::OwlThread& owl);

    virtual owl::Formula parse_string_with_factory(
            owl::FormulaFactory& factory,
            const std::string& text,
            std::vector<std::string>& inputs, std::vector<std::string>& outputs
    ) const = 0;

public:
    virtual ~Parser();

    std::string parse_file(const std::string& input_file);
    owl::Formula parse_string(const std::string& input_string, std::vector<std::string>& inputs, std::vector<std::string>& outputs, const bool print_formula = false) const;
};

}
