#include "TLSFParser.h"

namespace ltl {

TLSFParser::TLSFParser(const owl::OwlThread& owl) : Parser(owl) { }

TLSFParser::~TLSFParser() { }

owl::Formula TLSFParser::parse_string_with_factory(
        owl::FormulaFactory& factory,
        const std::string& text,
        std::vector<std::string>& inputs, std::vector<std::string>& outputs
) const {
    // Create list of variables for parser
    std::vector<std::string> variables;
    int num_inputs = -1;

    owl::Formula parsedFormula = factory.parseTlsf(text, variables, num_inputs);

    inputs.insert(inputs.end(), variables.cbegin(), variables.cbegin() + num_inputs);
    outputs.insert(outputs.end(), variables.cbegin() + num_inputs, variables.cend());

    return parsedFormula;
}

}
